searchData={"content_type":"text/markdown","items":[{"doc":"Documentation for `Kujira`.","ref":"Kujira.html","title":"Kujira","type":"module"},{"doc":"Convenience methods for querying CosmWasm smart contracts on Kujira","ref":"Kujira.Contract.html","title":"Kujira.Contract","type":"module"},{"doc":"","ref":"Kujira.Contract.html#by_code/2","title":"Kujira.Contract.by_code/2","type":"function"},{"doc":"","ref":"Kujira.Contract.html#by_codes/2","title":"Kujira.Contract.by_codes/2","type":"function"},{"doc":"","ref":"Kujira.Contract.html#get/2","title":"Kujira.Contract.get/2","type":"function"},{"doc":"","ref":"Kujira.Contract.html#list/3","title":"Kujira.Contract.list/3","type":"function"},{"doc":"Queries the full, raw contract state at an address. Default 1h cache","ref":"Kujira.Contract.html#query_state_all/3","title":"Kujira.Contract.query_state_all/3","type":"function"},{"doc":"","ref":"Kujira.Contract.html#query_state_smart/3","title":"Kujira.Contract.query_state_smart/3","type":"function"},{"doc":"Streams the current contract state","ref":"Kujira.Contract.html#stream_state_all/2","title":"Kujira.Contract.stream_state_all/2","type":"function"},{"doc":"Kujira's lending platform.\n\nIt has a vault-market architecture, where multiple Market can draw down from a single Vault. A Market must be whitelisted,\nas the repayment is guaranteed by its own execution logic, e.g. being over-collateralised and having a connection to Orca\nto liquidate collateral when needed","ref":"Kujira.Ghost.html","title":"Kujira.Ghost","type":"module"},{"doc":"Fetches the Market contract and its current config from the chain.\n\nConfig is very very rarely changed, if ever, and so this function is Memoized by default.\nClear with `Memoize.invalidate(Kujira.Ghost, :get_market, [address])`","ref":"Kujira.Ghost.html#get_market/2","title":"Kujira.Ghost.get_market/2","type":"function"},{"doc":"Fetches the Vault contract and its current config from the chain.\n\nConfig is very very rarely changed, if ever, and so this function is Memoized by default.\nClear with `Memoize.invalidate(Kujira.Ghost, :get_vault, [address])`","ref":"Kujira.Ghost.html#get_vault/2","title":"Kujira.Ghost.get_vault/2","type":"function"},{"doc":"Fetches all Markets. This will only change when config changes or new Markets are added.\nIt's Memoized, clearing every 24h.\n\nManually clear with `Memoize.invalidate(Kujira.Ghost, :list_markets)`","ref":"Kujira.Ghost.html#list_markets/2","title":"Kujira.Ghost.list_markets/2","type":"function"},{"doc":"Fetches all Vaults. This will only change when config changes or new Vaults are added.\nIt's Memoized, clearing every 24h.\n\nManually clear with `Memoize.invalidate(Kujira.Ghost, :list_vaults)`","ref":"Kujira.Ghost.html#list_vaults/2","title":"Kujira.Ghost.list_vaults/2","type":"function"},{"doc":"Loads the current Status into the Market","ref":"Kujira.Ghost.html#load_market/2","title":"Kujira.Ghost.load_market/2","type":"function"},{"doc":"Loads the Market into a format that Orca can consume for health reporting.\nIt's Memoized due to the call to `Contract.query_state_all`, clearing every 10m.\n\nManually clear with `Memoize.invalidate(Kujira.Contract, :query_state_all, [market.address])`","ref":"Kujira.Ghost.html#load_orca_market/3","title":"Kujira.Ghost.load_orca_market/3","type":"function"},{"doc":"Loads a Position by borrower address","ref":"Kujira.Ghost.html#load_position/3","title":"Kujira.Ghost.load_position/3","type":"function"},{"doc":"Loads the current Status into the Vault","ref":"Kujira.Ghost.html#load_vault/2","title":"Kujira.Ghost.load_vault/2","type":"function"},{"doc":"","ref":"Kujira.Ghost.html#load_vault_oracle_price/2","title":"Kujira.Ghost.load_vault_oracle_price/2","type":"function"},{"doc":"Creates a lazy stream for fetching all positions for a Market","ref":"Kujira.Ghost.html#stream_positions/3","title":"Kujira.Ghost.stream_positions/3","type":"function"},{"doc":"A Ghoat market taked deposits of collateral_token, and allows borrowing of the vault.deposit_token, up to the maximum LTV as quoted by the oracle denoms","ref":"Kujira.Ghost.Market.html","title":"Kujira.Ghost.Market","type":"module"},{"doc":"* `:address` - The address of the market\n\n* `:owner` - The owner of the market\n\n* `:vault_address` - The address of Vault that the Market draws from\n\n* `:orca_address` - The address of the Orca Queue that is used to liquidate the collateral token\n\n* `:collateral_token` - The token used to back the loan\n\n* `:collateral_oracle_denom` - The denom string that is used to price the collateral token\n\n* `:max_ltv` - MAximum loan-to-value ratio of a position\n\n* `:full_liquidation_threshold` - The value of collateral (as priced by collateral oracle, 6dp), below which a position is 100% liquidated\n\n* `:partial_liquidation_target` - The target LTV when a position is partially liquidated\n\n* `:borrow_fee` - The amount of the borrowed asset retained as a fee when borrow amount is increased","ref":"Kujira.Ghost.Market.html#module-fields","title":"Fields - Kujira.Ghost.Market","type":"module"},{"doc":"","ref":"Kujira.Ghost.Market.html#from_config/2","title":"Kujira.Ghost.Market.from_config/2","type":"function"},{"doc":"","ref":"Kujira.Ghost.Market.html#t:t/0","title":"Kujira.Ghost.Market.t/0","type":"type"},{"doc":"The current deposit and borrow totals","ref":"Kujira.Ghost.Market.Status.html","title":"Kujira.Ghost.Market.Status","type":"module"},{"doc":"* `:deposited` - The amount of collateral_token deposited\n\n* `:borrowed` - The amount of the Vault deposit_token borrowed","ref":"Kujira.Ghost.Market.Status.html#module-fields","title":"Fields - Kujira.Ghost.Market.Status","type":"module"},{"doc":"","ref":"Kujira.Ghost.Market.Status.html#from_query/1","title":"Kujira.Ghost.Market.Status.from_query/1","type":"function"},{"doc":"","ref":"Kujira.Ghost.Market.Status.html#t:t/0","title":"Kujira.Ghost.Market.Status.t/0","type":"type"},{"doc":"An item representing the collateral deposit vs debt position of a particular address for a particular market","ref":"Kujira.Ghost.Position.html","title":"Kujira.Ghost.Position","type":"module"},{"doc":"* `:market` - The market where the position is held\n\n* `:holder` - The address that owns the position\n\n* `:collateral_amount` - The amount of collateral_token that has been deposited\n\n* `:debt_shares` - The amount of debt_token minted and owned by this position\n\n* `:debt_amount` - The resultant amount of debt owed, based on the `debt_ratio`","ref":"Kujira.Ghost.Position.html#module-fields","title":"Fields - Kujira.Ghost.Position","type":"module"},{"doc":"","ref":"Kujira.Ghost.Position.html#from_query/3","title":"Kujira.Ghost.Position.from_query/3","type":"function"},{"doc":"Returns all adjustments to positions found in the tx response","ref":"Kujira.Ghost.Position.html#from_tx_response/1","title":"Kujira.Ghost.Position.from_tx_response/1","type":"function"},{"doc":"The direction of the adjustment to the Position: collateral deposit, collateral withdrawal, debt borrow, debt repay","ref":"Kujira.Ghost.Position.html#t:adjustment/0","title":"Kujira.Ghost.Position.adjustment/0","type":"type"},{"doc":"","ref":"Kujira.Ghost.Position.html#t:t/0","title":"Kujira.Ghost.Position.t/0","type":"type"},{"doc":"A central vault for deposits of a specific deposit_token, which is lent to the Vault's markets, and interest earned on deposits","ref":"Kujira.Ghost.Vault.html","title":"Kujira.Ghost.Vault","type":"module"},{"doc":"* `:address` - The address of the market\n\n* `:owner` - The owner of the market\n\n* `:deposit_token` - The token deposited into the vault to be lent\n\n* `:oracle_denom` - The denom string that is used to price the deposit token\n\n* `:receipt_token` - The token minted on deposit, that represents ownership of that deposit\n\n* `:debt_token` - The token minted and sent to a Market when borrowing, use as an accounting tool to accrue interest on debt\n\n* `:markets` - The whitelisted markets that are allowed to borrow from the Vault","ref":"Kujira.Ghost.Vault.html#module-fields","title":"Fields - Kujira.Ghost.Vault","type":"module"},{"doc":"","ref":"Kujira.Ghost.Vault.html#from_config/2","title":"Kujira.Ghost.Vault.from_config/2","type":"function"},{"doc":"","ref":"Kujira.Ghost.Vault.html#t:t/0","title":"Kujira.Ghost.Vault.t/0","type":"type"},{"doc":"The current deposit and borrow totals","ref":"Kujira.Ghost.Vault.Status.html","title":"Kujira.Ghost.Vault.Status","type":"module"},{"doc":"* `:deposited` - The amount of deposit_token deposited\n\n* `:borrowed` - The amount of the Vault deposit_token lent out\n\n* `:rate` - The current interest rate charged on lent tokens\n\n* `:deposit_ratio` - The ratio between deposit_token and receipt_token\n\n* `:debt_ratio` - The ratiop between the debt_token and the amount of deposit_token owed by the borrowing Market","ref":"Kujira.Ghost.Vault.Status.html#module-fields","title":"Fields - Kujira.Ghost.Vault.Status","type":"module"},{"doc":"","ref":"Kujira.Ghost.Vault.Status.html#from_query/1","title":"Kujira.Ghost.Vault.Status.from_query/1","type":"function"},{"doc":"Returns all adjustments to the Vault.Status contained in a tx_response","ref":"Kujira.Ghost.Vault.Status.html#from_tx_response/1","title":"Kujira.Ghost.Vault.Status.from_tx_response/1","type":"function"},{"doc":"The direction of the adjustment to the Vault Status: user deposit, user withdrawal, market borrow, market repay","ref":"Kujira.Ghost.Vault.Status.html#t:adjustment/0","title":"Kujira.Ghost.Vault.Status.adjustment/0","type":"type"},{"doc":"","ref":"Kujira.Ghost.Vault.Status.html#t:t/0","title":"Kujira.Ghost.Vault.Status.t/0","type":"type"},{"doc":"Utility functions for querying the on-chain oracle","ref":"Kujira.Oracle.html","title":"Kujira.Oracle","type":"module"},{"doc":"","ref":"Kujira.Oracle.html#load_price/2","title":"Kujira.Oracle.load_price/2","type":"function"},{"doc":"Methods for querying the Orca Liquidation Queues, and related data","ref":"Kujira.Orca.html","title":"Kujira.Orca","type":"module"},{"doc":"Fetches the Queue contract and its current config from the chain.\n\nConfig is very very rarely changed, if ever, and so this function is Memoized by default.\nClear with `Memoize.invalidate(Kujira.Orca, :get_queue, [address])`","ref":"Kujira.Orca.html#get_queue/2","title":"Kujira.Orca.get_queue/2","type":"function"},{"doc":"Fetches all Liquidation Queues. This will only change when config changes or new Queues are added.\nIt's Memoized, clearing every 24h.\n\nManually clear with `Memoize.invalidate(Kujira.Orca, :list_queues)`","ref":"Kujira.Orca.html#list_queues/2","title":"Kujira.Orca.list_queues/2","type":"function"},{"doc":"Loads a bid for a specific Queue","ref":"Kujira.Orca.html#load_bid/3","title":"Kujira.Orca.load_bid/3","type":"function"},{"doc":"Loads a user's bids for a specific Queue","ref":"Kujira.Orca.html#load_bids/4","title":"Kujira.Orca.load_bids/4","type":"function"},{"doc":"Loads the current contract state into the Queue; the totals of each bid pool","ref":"Kujira.Orca.html#load_queue/2","title":"Kujira.Orca.load_queue/2","type":"function"},{"doc":"A bid placed by a user to buy liquidated collateral at a specific discount from the market price","ref":"Kujira.Orca.Bid.html","title":"Kujira.Orca.Bid","type":"module"},{"doc":"* `:id` - The unique ID of the bid\n\n* `:bid_amount` - The remaining amount of the bid_token\n\n* `:filled_amount` - The amount of collateral available for withdrawal\n\n* `:premium` - The bid discount on the market rate\n\n* `:activation_time` - When not nil, the bid must be activated at or after this time","ref":"Kujira.Orca.Bid.html#module-fields","title":"Fields - Kujira.Orca.Bid","type":"module"},{"doc":"","ref":"Kujira.Orca.Bid.html#from_query/2","title":"Kujira.Orca.Bid.from_query/2","type":"function"},{"doc":"Returns all new bids found in a specific transaction","ref":"Kujira.Orca.Bid.html#from_tx_response/2","title":"Kujira.Orca.Bid.from_tx_response/2","type":"function"},{"doc":"","ref":"Kujira.Orca.Bid.html#t:t/0","title":"Kujira.Orca.Bid.t/0","type":"type"},{"doc":"An individual liquidation, as seen by Orca. These can be duplicated as the liquidating market\nwill also have something that represents the liquidation, but these may be different.","ref":"Kujira.Orca.Liquidation.html","title":"Kujira.Orca.Liquidation","type":"module"},{"doc":"* `:txhash` - The hash of the transaction the liqdation ocurred in\n\n* `:height` - The block height that included the transaction\n\n* `:timestamp` - The timestamp of the block\n\n* `:queue_address` - The address of the liquidation queue that processed the liquidation\n\n* `:market_address` - The market that requested the liquidation\n\n* `:collateral_amount` - The amount of collateral liquidated by the market\n\n* `:bid_amount` - The amount of bid_token that was consumed during the liquidation\n\n* `:repay_amount` - The amount of bid_token that was returned to the liquidating market\n\n* `:fee_amount` - The amount of the bid_token that was retained as a fee","ref":"Kujira.Orca.Liquidation.html#module-fields","title":"Fields - Kujira.Orca.Liquidation","type":"module"},{"doc":"Returns all liquidations found in a specific transaction","ref":"Kujira.Orca.Liquidation.html#from_tx_response/1","title":"Kujira.Orca.Liquidation.from_tx_response/1","type":"function"},{"doc":"","ref":"Kujira.Orca.Liquidation.html#t:t/0","title":"Kujira.Orca.Liquidation.t/0","type":"type"},{"doc":"We define a Market, as far as Orca is concerned, in order to be able to standardise\nand aggregate the health of the various markets that any given liquidation queue can liquidate","ref":"Kujira.Orca.Market.html","title":"Kujira.Orca.Market","type":"module"},{"doc":"* `:address` - The address of the market\n\n* `:health` - A bucketed map of market health -\n  key: liquidation price,\n  value: total collateral between this (inclusive) and the previous liquidation price (exclusive)","ref":"Kujira.Orca.Market.html#module-fields","title":"Fields - Kujira.Orca.Market","type":"module"},{"doc":"","ref":"Kujira.Orca.Market.html#t:t/0","title":"Kujira.Orca.Market.t/0","type":"type"},{"doc":"A pool of bid tokens at a specific premium %, for a specific Queue","ref":"Kujira.Orca.Pool.html","title":"Kujira.Orca.Pool","type":"module"},{"doc":"* `:premium` - The premium \"charged\" above the current market rate (ie the discount that the collateral is bought for)\n\n* `:total` - The total amount of activated bid token in the pool","ref":"Kujira.Orca.Pool.html#module-fields","title":"Fields - Kujira.Orca.Pool","type":"module"},{"doc":"Calculates a new Pool from the config on the Queue","ref":"Kujira.Orca.Pool.html#calculate/2","title":"Kujira.Orca.Pool.calculate/2","type":"function"},{"doc":"","ref":"Kujira.Orca.Pool.html#load/2","title":"Kujira.Orca.Pool.load/2","type":"function"},{"doc":"","ref":"Kujira.Orca.Pool.html#t:t/0","title":"Kujira.Orca.Pool.t/0","type":"type"},{"doc":"An individual Orca Liquidation Queue","ref":"Kujira.Orca.Queue.html","title":"Kujira.Orca.Queue","type":"module"},{"doc":"* `:address` - The contract address\n\n* `:owner` - The account authorized to make changes to contract config\n\n* `:collateral_token` - The token that is being liquidated\n\n* `:bid_token` - The token that is used to buy the collateral\n\n* `:bid_pools` - The aggregate amounts of bids at each supported discount amount. The contract confug contains `max_slot` and `premium_rate_per_slot`, which define these pools\n\n* `:activation_threshold` - The total amount of bids, above which the activation_delay must pass before a bid can be activated. This is `bid_threshold` on the contract interfaace\n\n* `:activation_delay` - The time in seconds that must pass before a bid can be activated. This is `waiting_period` on the contract interface","ref":"Kujira.Orca.Queue.html#module-fields","title":"Fields - Kujira.Orca.Queue","type":"module"},{"doc":"","ref":"Kujira.Orca.Queue.html#from_config/2","title":"Kujira.Orca.Queue.from_config/2","type":"function"},{"doc":"Assigns the current state to the bd_pools from a direct contract query response","ref":"Kujira.Orca.Queue.html#load_pools/2","title":"Kujira.Orca.Queue.load_pools/2","type":"function"},{"doc":"Enumerates all bid pools based on contract config","ref":"Kujira.Orca.Queue.html#populate_pools/3","title":"Kujira.Orca.Queue.populate_pools/3","type":"function"},{"doc":"","ref":"Kujira.Orca.Queue.html#t:t/0","title":"Kujira.Orca.Queue.t/0","type":"type"},{"doc":"Metadata for tokens on the Kujira Blockchain","ref":"Kujira.Token.html","title":"Kujira.Token","type":"module"},{"doc":"","ref":"Kujira.Token.html#from_denom/1","title":"Kujira.Token.from_denom/1","type":"function"},{"doc":"","ref":"Kujira.Token.html#t:t/0","title":"Kujira.Token.t/0","type":"type"},{"doc":"","ref":"Mix.Tasks.DumpTx.html","title":"mix dump_tx","type":"task"},{"doc":"","ref":"Mix.Tasks.DumpTx.html#run/1","title":"Mix.Tasks.DumpTx.run/1","type":"function"}]}